diff -urN ../netqmail-1.05-toaster-orig/netqmail-1.05/ssl_timeoutio.h ./netqmail-1.05/ssl_timeoutio.h
--- ../netqmail-1.05-toaster-orig/netqmail-1.05/ssl_timeoutio.h	Wed Dec 31 18:00:00 1969
+++ ./netqmail-1.05/ssl_timeoutio.h	Fri Feb 13 13:54:14 2004
@@ -0,0 +1,21 @@
+#ifndef SSL_TIMEOUTIO_H
+#define SSL_TIMEOUTIO_H
+
+#include <openssl/ssl.h>
+
+/* the version is like this: 0xMNNFFPPS: major minor fix patch status */
+#if OPENSSL_VERSION_NUMBER < 0x00906000L
+# error "Need OpenSSL version at least 0.9.6"
+#endif
+
+int ssl_timeoutconn(long t, int rfd, int wfd, SSL *ssl);
+int ssl_timeoutaccept(long t, int rfd, int wfd, SSL *ssl);
+int ssl_timeoutrehandshake(long t, int rfd, int wfd, SSL *ssl);
+
+int ssl_timeoutread(long t, int rfd, int wfd, SSL *ssl, char *buf, int len);
+int ssl_timeoutwrite(long t, int rfd, int wfd, SSL *ssl, char *buf, int len);
+
+int ssl_timeoutio(
+  int (*fun)(), long t, int rfd, int wfd, SSL *ssl, char *buf, int len);
+
+#endif
diff -urN ../netqmail-1.05-toaster-orig/netqmail-1.05/strpidt.c ./netqmail-1.05/strpidt.c
--- ../netqmail-1.05-toaster-orig/netqmail-1.05/strpidt.c	Wed Dec 31 18:00:00 1969
+++ ./netqmail-1.05/strpidt.c	Fri Feb 13 13:54:14 2004
@@ -0,0 +1,26 @@
+/*
+** Copyright 1998 - 2000 Double Precision, Inc.
+** See COPYING for distribution information.
+*/
+
+#if	HAVE_CONFIG_H
+#include	"config.h"
+#endif
+#include	"numlib.h"
+#include	<string.h>
+
+static const char rcsid[]="$Id: netqmail-1.05-toaster-2.9.patch,v 1.1 2004/03/07 05:31:41 matt Exp $";
+
+char *str_pid_t(pid_t t, char *arg)
+{
+char	buf[NUMBUFSIZE];
+char	*p=buf+sizeof(buf)-1;
+
+	*p=0;
+	do
+	{
+		*--p= '0' + (t % 10);
+		t=t / 10;
+	} while(t);
+	return (strcpy(arg, p));
+}
diff -urN ../netqmail-1.05-toaster-orig/netqmail-1.05/strtimet.c ./netqmail-1.05/strtimet.c
--- ../netqmail-1.05-toaster-orig/netqmail-1.05/strtimet.c	Wed Dec 31 18:00:00 1969
+++ ./netqmail-1.05/strtimet.c	Fri Feb 13 13:54:14 2004
@@ -0,0 +1,26 @@
+/*
+** Copyright 1998 - 2000 Double Precision, Inc.
+** See COPYING for distribution information.
+*/
+
+#if	HAVE_CONFIG_H
+#include	"config.h"
+#endif
+#include	"numlib.h"
+#include	<string.h>
+
+static const char rcsid[]="$Id: netqmail-1.05-toaster-2.9.patch,v 1.1 2004/03/07 05:31:41 matt Exp $";
+
+char *str_time_t(time_t t, char *arg)
+{
+char	buf[NUMBUFSIZE];
+char	*p=buf+sizeof(buf)-1;
+
+	*p=0;
+	do
+	{
+		*--p= '0' + (t % 10);
+		t=t / 10;
+	} while(t);
+	return (strcpy(arg, p));
+}
diff -urN ../netqmail-1.05-toaster-orig/netqmail-1.05/tls.c ./netqmail-1.05/tls.c
--- ../netqmail-1.05-toaster-orig/netqmail-1.05/tls.c	Wed Dec 31 18:00:00 1969
+++ ./netqmail-1.05/tls.c	Fri Feb 13 13:54:14 2004
@@ -0,0 +1,26 @@
+#include "exit.h"
+#include "error.h"
+#include <openssl/ssl.h>
+#include <openssl/err.h>
+
+int smtps = 0;
+SSL *ssl = NULL;
+
+void ssl_free(SSL *myssl) { SSL_shutdown(myssl); SSL_free(myssl); }
+void ssl_exit(int status) { if (ssl) ssl_free(ssl); _exit(status); }
+
+const char *strerror(int);
+const char *ssl_error()
+{
+  int r = ERR_get_error();
+  if (!r) return NULL;
+  SSL_load_error_strings();
+  return ERR_error_string(r, NULL);
+}
+const char *ssl_strerror()
+{
+  const char *err = ssl_error();
+  if (err) return err;
+  if (!errno) return 0;
+  return errno == error_timeout ? "timed out" : strerror(errno);
+}
diff -urN ../netqmail-1.05-toaster-orig/netqmail-1.05/tls.h ./netqmail-1.05/tls.h
--- ../netqmail-1.05-toaster-orig/netqmail-1.05/tls.h	Wed Dec 31 18:00:00 1969
+++ ./netqmail-1.05/tls.h	Fri Feb 13 13:54:14 2004
@@ -0,0 +1,16 @@
+#ifndef TLS_H
+#define TLS_H
+
+#include <openssl/ssl.h>
+
+extern int smtps;
+extern SSL *ssl;
+
+void ssl_free(SSL *myssl);
+void ssl_exit(int status);
+# define _exit ssl_exit
+
+const char *ssl_error();
+const char *ssl_strerror();
+
+#endif
diff -urN ../netqmail-1.05-toaster-orig/netqmail-1.05/update_tmprsadh.sh ./netqmail-1.05/update_tmprsadh.sh
--- ../netqmail-1.05-toaster-orig/netqmail-1.05/update_tmprsadh.sh	Wed Dec 31 18:00:00 1969
+++ ./netqmail-1.05/update_tmprsadh.sh	Fri Feb 13 14:23:51 2004
@@ -0,0 +1,25 @@
+#!/bin/sh
+
+# Update temporary RSA and DH keys
+# Frederik Vermeulen 2003-12-28 GPL
+
+umask 0077 || exit 0
+
+export PATH="$PATH:/usr/local/bin/ssl"
+
+openssl genrsa -out QMAIL/control/rsa512.new 512
+chmod 660 QMAIL/control/rsa512.new
+chown vpopmail:qmail QMAIL/control/rsa512.new 
+mv -f QMAIL/control/rsa512.new QMAIL/control/rsa512.pem
+echo
+
+openssl dhparam -2 -out QMAIL/control/dh512.new 512
+chmod 660 QMAIL/control/dh512.new
+chown vpopmail:qmail QMAIL/control/dh512.new
+mv -f QMAIL/control/dh512.new QMAIL/control/dh512.pem
+echo
+
+openssl dhparam -2 -out QMAIL/control/dh1024.new 1024
+chmod 660 QMAIL/control/dh1024.new
+chown vpopmail:qmail QMAIL/control/dh1024.new
+mv -f QMAIL/control/dh1024.new QMAIL/control/dh1024.pem
